version: "3.5"
services:
  php:
    build:
      dockerfile: ./docker/php/Dockerfile
      context: .
    image: php:xdebug
    volumes:
      - ./docker/php/xdebug.enable.ini:/usr/local/etc/php/conf.d/20-xdebug.ini # Enabling XDebug
      - ./:/var/www:rw
    environment:
      ENV_DATABASE_HOST: ${ENV_DATABASE_HOST-db.test}
      ENV_DATABASE_NAME: ${ENV_DATABASE_NAME-db}
      ENV_DATABASE_USER: ${ENV_DATABASE_USER-user}
      ENV_DATABASE_PASS: ${ENV_DATABASE_PASS-passw0rd}
      ENV_APPLICATION_ENV: ${ENV_APPLICATION_ENV-development}
      ENV_CACHE_HOST: ${ENV_CACHE_HOST-cache.test}
      ENV_MAIL_HOST: ${ENV_MAIL_HOST-mail.test}
    links:
      - db:${ENV_DATABASE_HOST-db.test}
      - mail:${ENV_MAIL_HOST-mail.test}
      - cache:${ENV_CACHE_HOST-cache.test}
    depends_on:
      - db
      - mail
      - cache
    networks:
      default:
          aliases:
            - ${ENV_UPSTREAM_HOST-php.test}

  nginx:
    image: twistersfury/nginx
    volumes:
      - ./docker/nginx/default.conf:/mnt/nginx.template
      - ./public:/var/www/public
    environment:
      ENV_APPLICATION_ENV: ${ENV_APPLICATION_ENV-development}
      ENV_DOMAIN_NAME: ${ENV_DOMAIN_NAME-nginx.test}
      ENV_UPSTREAM_HOST: ${ENV_UPSTREAM_HOST-php.test}:${ENV_UPSTREAM_PORT-9000}
      ENV_IGNORE_HTTPS: ${ENV_IGNORE_HTTPS-on}
    networks:
      default:
        aliases:
          - ${ENV_DOMAIN_NAME-nginx.test}
    links:
      - php:${ENV_UPSTREAM_HOST-php.test}
    ports:
      - 80:80/tcp
    depends_on:
      - php


  db:
    image: mysql:5.7
    environment:
      MYSQL_ROOT_PASSWORD: ${MYSQL_ROOT_PASSWORD-root}
      MYSQL_DATABASE: ${ENV_DATABASE_NAME-db}
      MYSQL_USER: ${ENV_DATABASE_USER-user}
      MYSQL_PASSWORD: ${ENV_DATABASE_PASS-passw0rd}
    ports:
      - 3306:3306/tcp
    volumes:
      - mysql:/var/lib/mysql
    networks:
      default:
        aliases:
          - ${ENV_DB_HOST-db.test}

  mail:
    image: mailhog/mailhog
    user: root
    environment:
      MH_SMTP_BIND_ADDR: 0.0.0.0:25
      MH_UI_BIND_ADDR: 0.0.0.0:80
      MH_HOSTNAME: ${ENV_MAIL_HOST-mail.test}
      MH_API_BIND_ADDR: 0.0.0.0:80
    ports:
      - 8080:80/tcp
      - 8025:25/tcp
    networks:
      default:
        aliases:
          - ${ENV_MAIL_HOST-mail.test}

  cache:
      image: redis
      networks:
          default:
              aliases:
                - ${ENV_CACHE_HOST-redis.test}

  selenium:
    image: selenium/standalone-chrome:3.13.0
    networks:
      default:
        aliases:
          - ${ENV_SELENIUM_HOST-selenium.test}
    ports:
      - 4444:4444/tcp

volumes:
  mysql:
    driver: "local"

networks:
    default:
        name: phalcon
